// SkinDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SkinDialog.h"

// CSkinDialog dialog
CSkinDialog::CSkinDialog(UINT nResourceID, CWnd* pParent /*=NULL*/)
	: CDialog(nResourceID, pParent)
{
	//{{AFX_DATA_INIT(CShapeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_CtlColorBrush.CreateSolidBrush(Global.GetRGB(IDX_RGB_BACKGROUND));

	m_nClickedBox	= CLICKED_BOX_NONE;

	m_bTracking		= FALSE;

	m_bDraging		= FALSE;
	m_bSizeCursor	= FALSE;

	m_bActive		= FALSE;

	m_cfText		= RGB(0, 0, 0);
	m_cfMask		= RGB(255, 0, 255);

	m_hBmpCapL		= NULL;
	m_hBmpCapM		= NULL;
	m_hBmpCapR		= NULL;
	m_hBmpFrmL		= NULL;
	m_hBmpFrmLB		= NULL;
	m_hBmpFrmB		= NULL;
	m_hBmpFrmR		= NULL;
	m_hBmpFrmRB		= NULL;

	m_hBmpMinimize	= NULL;
	m_hBmpMaximize	= NULL;
	m_hBmpRestore	= NULL;
	m_hBmpExit		= NULL;
	m_hBmpCustom    = NULL;

	m_hIcon			= NULL;
	m_bShowTitle    = TRUE;

	m_nMinWidth = 0;
	m_nMinHeight = 0;

	m_bExitBtnActHide = FALSE;

	m_bCloseEvent = FALSE;

	m_cfBK = RGB(244, 244, 244);

	memset(&m_sizeCapL, 0x00, sizeof(SIZE));
	memset(&m_sizeCapM, 0x00, sizeof(SIZE));
	memset(&m_sizeCapR, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmL, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmLB, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmB, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmRB, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmR, 0x00, sizeof(SIZE));
	memset(&m_sizeBox, 0x00, sizeof(SIZE));
	memset(&m_sizeCustomBox, 0x00, sizeof(SIZE));

	m_bShowCustomBtn = FALSE;
	m_bMoveTransParent = TRUE;
}

void CSkinDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSkinDialog, CDialog)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_NCPAINT()
	ON_WM_NCACTIVATE()
	ON_WM_NCCALCSIZE()
	ON_WM_CTLCOLOR()
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()

BOOL CSkinDialog::SetLeftTopBitmap(CString strPath)
{
	Global.SetLeftTopBitmap(strPath);
	m_sizeCapL		= Global.GetBitmapSize(IDX_BMP_CAPTION_LEFT);
	m_hBmpCapL		= Global.GetBitmap(IDX_BMP_CAPTION_LEFT);

	return TRUE;
}

BOOL CSkinDialog::SetCenterTopBitmap(CString strPath)
{
	Global.SetCenterTopBitmap(strPath);
	m_sizeCapM		= Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
	m_hBmpCapM		= Global.GetBitmap(IDX_BMP_CAPTION_CENTER);

	return TRUE;
}

BOOL CSkinDialog::SetRightTopBitmap(CString strPath)
{
	Global.SetRightTopBitmap(strPath);
	m_sizeCapR		= Global.GetBitmapSize(IDX_BMP_CAPTION_RIGHT);
	m_hBmpCapR		= Global.GetBitmap(IDX_BMP_CAPTION_RIGHT);

	return TRUE;
}

BOOL CSkinDialog::SetLeftBorderBitmap(CString strPath)
{
	Global.SetLeftBorderBitmap(strPath);
	m_sizeFrmL		= Global.GetBitmapSize(IDX_BMP_FRAME_LEFT);
	m_hBmpFrmL		= Global.GetBitmap(IDX_BMP_FRAME_LEFT);

	return TRUE;
}

BOOL CSkinDialog::SetRightBorderBitmap(CString strPath)
{
	Global.SetRightBorderBitmap(strPath);
	m_sizeFrmR		= Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT);
	m_hBmpFrmR		= Global.GetBitmap(IDX_BMP_FRAME_RIGHT);

	return TRUE;
}

BOOL CSkinDialog::SetLeftBottomBitmap(CString strPath)
{
	Global.SetLeftBottomBitmap(strPath);
	m_sizeFrmLB		= Global.GetBitmapSize(IDX_BMP_FRAME_LEFT_BOTTOM);
	m_hBmpFrmLB		= Global.GetBitmap(IDX_BMP_FRAME_LEFT_BOTTOM);

	return TRUE;
}

BOOL CSkinDialog::SetCenterBottomBitmap(CString strPath)
{
	Global.SetCenterBottomBitmap(strPath);
	m_sizeFrmB		= Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
	m_hBmpFrmB		= Global.GetBitmap(IDX_BMP_FRAME_BOTTOM);

	return TRUE;
}

BOOL CSkinDialog::SetRightBottomBitmap(CString strPath)
{
	Global.SetRightBottomBitmap(strPath);
	m_sizeFrmRB		= Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT_BOTTOM);
	m_hBmpFrmRB		= Global.GetBitmap(IDX_BMP_FRAME_RIGHT_BOTTOM);

	return TRUE;
}

BOOL CSkinDialog::SetDlgIcon(CString strPath)
{
	Global.SetDlgIcon(strPath);
	m_hIcon			= Global.GetIcon(ICON16);			

	return TRUE;
}

BOOL CSkinDialog::SetMaxBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetMaxBitmaps(strNormalPath, strOverPath, strClickPath);
	m_hBmpMaximize	= Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);

	return TRUE;
}

BOOL CSkinDialog::SetRestoreBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetRestoreBitmaps(strNormalPath, strOverPath, strClickPath);
	m_hBmpRestore	= Global.GetBitmap(IDX_BMP_BOX_RESTORE);

	return TRUE;
}

BOOL CSkinDialog::SetMinBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetMinBitmaps(strNormalPath, strOverPath, strClickPath);
	m_hBmpMinimize	= Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);

	return TRUE;
}

BOOL CSkinDialog::SetExitBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetExitBitmaps(strNormalPath, strOverPath, strClickPath);
	m_sizeBox		= Global.GetBitmapSize(IDX_BMP_BOX_EXIT);
	m_hBmpExit		= Global.GetBitmap(IDX_BMP_BOX_EXIT);

	return TRUE;
}

BOOL CSkinDialog::SetCustomBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetCustomBitmaps(strNormalPath, strOverPath, strClickPath);
	m_sizeCustomBox		= Global.GetBitmapSize(IDX_BMP_BOX_CUSTOM);
	m_hBmpCustom		= Global.GetBitmap(IDX_BMP_BOX_CUSTOM);

	return TRUE;
}

void CSkinDialog::SetWindowMinSize(int nWidth, int nHeight)
{
	m_nMinWidth = nWidth;
	m_nMinHeight = nHeight;
}

void CSkinDialog::SetDlgBKColor(COLORREF bkcolor)
{
	m_cfBK = bkcolor;
}

CRect CSkinDialog::GetCustomBtnRect(void)
{
	return m_rcCustomBox;
}

void CSkinDialog::ShowCustomBtn(bool bShow)
{
	m_bShowCustomBtn = bShow;
}

void CSkinDialog::SetDlgIcon(UINT nResourceID)
{
	Global.SetDlgIcon(nResourceID);

	m_hIcon = Global.GetIcon(ICON16);
}

// CSkinDialog message handlers
void CSkinDialog::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	if (m_nMinWidth > 0 && m_nMinHeight > 0)
	{
		lpMMI->ptMinTrackSize.x = m_nMinWidth;
		lpMMI->ptMinTrackSize.y = m_nMinHeight;
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}

int CSkinDialog::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	ModifyStyle(WS_SYSMENU, 0);

	Global.SetRGB(IDX_RGB_MASK, RGB(255, 0, 255));
	Global.SetRGB(IDX_RGB_BACKGROUND, RGB(255, 255, 255));

	Global.SetRGB(IDX_RGB_FONT, RGB(51, 51, 51));
	Global.SetRGB(IDX_RGB_FONT_CAPTION, RGB(0, 0, 0));
	Global.SetRGB(IDX_RGB_FONT_CAPTION_INACTIVE, RGB(178, 178, 178));

	m_cfText = Global.GetRGB(IDX_RGB_FONT_CAPTION);
	m_cfMask = Global.GetRGB(IDX_RGB_MASK);	

	return 0;
}

HBRUSH CSkinDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd->IsKindOf(RUNTIME_CLASS(CButton)))
	{
		return (HBRUSH)m_CtlColorBrush;
	}

	return hbr;
}

void CSkinDialog::OnDestroy() 
{
	if (m_hRgnWnd)
		DeleteObject(m_hRgnWnd);
	if (m_CtlColorBrush.GetSafeHandle())
		m_CtlColorBrush.DeleteObject();	
	if (m_fntBold.GetSafeHandle())
		m_fntBold.DeleteObject();

	CDialog::OnDestroy();
}

void CSkinDialog::DrawFrame()
{
	if (!(GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION))
		return;

	int x = 0, y = 0, x2 = 0, y2 = 0, cx = 0, cy = 0;

	CRect rc;
	GetWindowRect(&rc);
	BOOL bIconic = IsIconic();
	BOOL bZoomed = IsZoomed();

	CWindowDC dc(this);	

	CDC BufferDC, tmpDC;
	BufferDC.CreateCompatibleDC(&dc);
	tmpDC.CreateCompatibleDC(&dc);

	CBitmap bmpBuffer, *pOldBitmap1 = NULL;
	HGDIOBJ hgdiobj;

	bmpBuffer.CreateCompatibleBitmap(&dc, rc.Width(), rc.Height());
	pOldBitmap1 = (CBitmap*)BufferDC.SelectObject(&bmpBuffer);

	x = 0;
	y = 0;
	cx = m_sizeCapL.cx;
	cy = m_sizeCapL.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapL);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = rc.Width() - m_sizeCapL.cx - m_sizeCapR.cx;
	cy = m_sizeCapM.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapM);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeCapM.cx, m_sizeCapM.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = m_sizeCapR.cx;
	cy = m_sizeCapR.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapR);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = 0;
	y = m_sizeCapL.cy;
	cx = m_sizeFrmL.cx;
	cy = rc.Height() - m_sizeCapL.cy - m_sizeFrmB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmL);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmL.cx, m_sizeFrmL.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	y += cy;
	cx = m_sizeFrmLB.cx;
	cy = m_sizeFrmLB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmLB);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx;
	cy = m_sizeFrmB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmB);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmB.cx, m_sizeFrmB.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = rc.Width() - m_sizeFrmR.cx;
	y = m_sizeCapR.cy;
	cx = m_sizeFrmR.cx;
	cy = rc.Height() - m_sizeCapR.cy - m_sizeFrmRB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmR);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmR.cx, m_sizeFrmR.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = rc.Width() - m_sizeFrmRB.cx;
	y += cy;
	cx = m_sizeFrmRB.cx;
	cy = m_sizeFrmRB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmRB);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);	
	tmpDC.SelectObject(hgdiobj);

	if (!bIconic)
	{
		if (bZoomed)
			::DrawIconEx(BufferDC.m_hDC, 15, 10, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);
		else
			::DrawIconEx(BufferDC.m_hDC, 15, 5, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);

		if (bZoomed)
			y = MARGIN_MAXIMIZED + 7;
		else
			y = MARGIN_MAXIMIZED + 4;

		hgdiobj = tmpDC.SelectObject(m_hBmpExit);
		x = rc.Width() - MARGIN_BOX - DEF_BTN_MARGIN_RIGHT_POS_X - m_sizeBox.cx;
		BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		if (m_hBmpMaximize)
		{
			if (!bZoomed)
			{
				hgdiobj = tmpDC.SelectObject(m_hBmpMaximize);
				x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;			
				BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
				tmpDC.SelectObject(hgdiobj);
			}
			else
			{
				hgdiobj = tmpDC.SelectObject(m_hBmpRestore);
				x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;			
				BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
				tmpDC.SelectObject(hgdiobj);
			}
		}

		if (m_hBmpMinimize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpMinimize);
			x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpCustom && m_bShowCustomBtn)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpCustom);
			x = x - DEF_SYSTEM_BTN_GAP - m_sizeCustomBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeCustomBox.cx, m_sizeCustomBox.cy, &tmpDC, 0, 0, SRCCOPY);
			m_rcCustomBox.left = x;
			m_rcCustomBox.right = x + m_sizeCustomBox.cx;
			m_rcCustomBox.top = y;
			m_rcCustomBox.bottom = y + m_sizeCustomBox.cy;
			tmpDC.SelectObject(hgdiobj);
		}
	}
	else
	{
		::DrawIconEx(BufferDC.m_hDC, 15, 5, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);

		hgdiobj = tmpDC.SelectObject(m_hBmpExit);
		x = rc.Width() - MARGIN_BOX - m_sizeBox.cx;
		BufferDC.BitBlt(x, MARGIN_MAXIMIZED, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		if (m_hBmpMaximize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpMaximize);
			x = x - m_sizeBox.cx;		
			BufferDC.BitBlt(x, MARGIN_MAXIMIZED, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpMinimize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpRestore);
			x = x - m_sizeBox.cx;		
			BufferDC.BitBlt(x, MARGIN_MAXIMIZED, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpCustom && m_bShowCustomBtn)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpCustom);
			x = x - m_sizeCustomBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeCustomBox.cx, m_sizeCustomBox.cx, &tmpDC, 0, 0, SRCCOPY);	
			m_rcCustomBox.left = x;
			m_rcCustomBox.right = x + m_sizeCustomBox.cx;
			m_rcCustomBox.top = y;
			m_rcCustomBox.bottom = y + m_sizeCustomBox.cy;

			tmpDC.SelectObject(hgdiobj);
		}
	}

	tmpDC.DeleteDC();

	BufferDC.SetBkMode(TRANSPARENT);

	CFont* font = GetFont();	
	CFont* pOldFont = NULL;
	
	if (!m_fntBold.GetSafeHandle() && font)
	{
		LOGFONT logFont;
		font->GetLogFont(&logFont);
		logFont.lfWeight = FW_BOLD;
		m_fntBold.CreateFontIndirect(&logFont);		
	}

	if (m_fntBold.GetSafeHandle())
		pOldFont = (CFont*)BufferDC.SelectObject(&m_fntBold);

	BufferDC.SetTextColor(m_cfText);

	BufferDC.SetTextAlign(TA_LEFT | TA_TOP);

	CString strTitle = _T("");
	GetWindowText(strTitle);
	if (!bIconic && pOldFont)
	{
		CRect rcTitle;
		rcTitle = rc;

		if (bZoomed)
		{
			rcTitle.left = 10;
			rcTitle.top = 10;				
		}
		else
		{
			rcTitle.left = 5;
			rcTitle.top = 5;
		}
		rcTitle.right = rc.Width() - (m_sizeBox.cx * 3) - 35;
		rcTitle.bottom = rcTitle.top + 15;

		LOGFONT lg;
		pOldFont->GetLogFont(&lg);
		if (strTitle.GetLength() * lg.lfWidth + 20 >= rcTitle.Width())
			strTitle = strTitle.Left(rcTitle.Width() / lg.lfWidth - 5) + _T("...");

		if (m_bShowTitle)
			BufferDC.DrawText(strTitle, rcTitle, DT_LEFT | DT_SINGLELINE);

		x = m_sizeFrmL.cx;
		y = m_sizeCapM.cy;
		x2 = rc.Width() - m_sizeFrmR.cx;
		y2 = rc.Height() - m_sizeFrmB.cy;	
		dc.ExcludeClipRect(x, y, x2, y2);
	}
	else
	{
		if (strTitle.GetLength() > 4)
			strTitle = strTitle.Left(4) + _T("...");

		if (m_bShowTitle)
			BufferDC.TextOut(30, (rc.Height() - dc.GetTextExtent(strTitle).cy) / 2, strTitle);
	}

	dc.BitBlt(0, 0, rc.Width(), rc.Height(), &BufferDC, 0, 0, SRCCOPY);

	if (pOldFont)
		BufferDC.SelectObject(pOldFont);

	BufferDC.SelectObject(pOldBitmap1);
	BufferDC.DeleteDC();
}

BOOL CSkinDialog::OnNcActivate(BOOL bActive)
{
	if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
	{
		DrawFrame();
		return TRUE;
	}
	else
	{
		return CDialog::OnNcActivate(bActive);
	}
}

void CSkinDialog::SetCtlColor(COLORREF crCtlColor)
{
	m_CtlColorBrush.DeleteObject();
	m_CtlColorBrush.CreateSolidBrush(crCtlColor);

	RedrawWindow();
}

BOOL CSkinDialog::PreTranslateMessage(MSG* pMsg) 
{
	if ((pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||
		 pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;
	}
	else if (pMsg->message == WM_NCLBUTTONDOWN ||
			 pMsg->message == WM_NCMOUSEMOVE ||
			 pMsg->message == WM_LBUTTONUP ||
			 pMsg->message == WM_NCLBUTTONUP ||
			 pMsg->message == WM_NCMOUSELEAVE)
	{
		if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
		{
			CRect rc;
			GetWindowRect(&rc);

			CRect rcExit(0, 0, 0, 0), rcMaximize(0, 0, 0, 0), rcMinimize(0, 0, 0, 0), rcCustom(0, 0, 0, 0);

			int x = 0, y = 0, cx = 0, cy = 0;

			SIZE sizeBox = Global.GetBitmapSize(IDX_BMP_BOX_EXIT);

			BOOL bZoomed = IsZoomed();
			BOOL bIconic = IsIconic();
			BOOL bLButton = KEYDOWN(VK_LBUTTON);

			if (bZoomed)
				y = rc.top + MARGIN_MAXIMIZED + 7;
			else
				y = rc.top + MARGIN_MAXIMIZED + 4;			

			rcExit.left = rc.right - MARGIN_BOX - sizeBox.cx - DEF_BTN_MARGIN_RIGHT_POS_X;
			rcExit.top = y;
			rcExit.right = rcExit.left+sizeBox.cx;
			rcExit.bottom = rcExit.top+sizeBox.cy;

			if (m_hBmpMaximize)
			{
				rcMaximize.left = rcExit.left - sizeBox.cx - DEF_SYSTEM_BTN_GAP;
				rcMaximize.top = y;
				rcMaximize.right = rcMaximize.left + sizeBox.cx;
				rcMaximize.bottom = rcMaximize.top + sizeBox.cy;
			}

			if (m_hBmpMinimize)
			{
				if (m_hBmpMaximize)
					rcMinimize.left = rcMaximize.left - sizeBox.cx - DEF_SYSTEM_BTN_GAP;
				else
					rcMinimize.left = rcExit.left - sizeBox.cx - DEF_SYSTEM_BTN_GAP;
				rcMinimize.top = y;
				rcMinimize.right = rcMinimize.left + sizeBox.cx;
				rcMinimize.bottom = rcMinimize.top + sizeBox.cy;
			}

			if (m_hBmpCustom)
			{
				rcCustom.left = rcMinimize.left - m_sizeCustomBox.cx - DEF_SYSTEM_BTN_GAP;
				rcCustom.top = y;
				rcCustom.right = rcCustom.left + m_sizeCustomBox.cx;
				rcCustom.bottom = rcCustom.top + m_sizeCustomBox.cy;
			}

			switch (pMsg->message)
			{
			case WM_NCLBUTTONDOWN:
				{
					if (rcExit.PtInRect(pMsg->pt))
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_EXIT;
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT_ON);
						DrawFrame();

						return TRUE;
					}
					else if (rcMaximize.PtInRect(pMsg->pt))
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_MAXIMIZE;
						if (IsZoomed())
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_ON);
						else
							m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE_ON);
						DrawFrame();

						return TRUE;
					}
					else if (rcMinimize.PtInRect(pMsg->pt))
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_MINIMIZE;
						if (bIconic)
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_ON);
						else
							m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE_ON);
						DrawFrame();

						return TRUE;
					}
					else if (rcCustom.PtInRect(pMsg->pt) && m_bShowCustomBtn)
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_CUSTOM;
						m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_CUSTOM_ON);
						DrawFrame();

						return TRUE;
					}
					else
					{
						m_nClickedBox = CLICKED_BOX_NONE;
					}
				}
				break;
			case WM_NCMOUSELEAVE:
				{
					m_bTracking = FALSE;
					if (m_nClickedBox == CLICKED_BOX_NONE)
					{					
						m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);
						m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);
						m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE);
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT);
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM);
						m_nClickedBox = CLICKED_BOX_NONE;

						DrawFrame();
					}
				}
				break;
			case WM_NCMOUSEMOVE:
				{
					if (!m_bTracking)
					{
						m_bTracking = TRUE;
						TRACKMOUSEEVENT t = { sizeof(TRACKMOUSEEVENT), TME_NONCLIENT|TME_LEAVE, m_hWnd, 0 };
						::TrackMouseEvent(&t);					
					}

					if (m_nClickedBox != CLICKED_BOX_NONE)
						break;
					
					m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);
					m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);
					m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE);
					m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT);	
					m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM);
					
					if (rcExit.PtInRect(pMsg->pt))
					{
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT_OVER);
					}
					else if (rcMaximize.PtInRect(pMsg->pt))
					{
						if (IsZoomed())
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_OVER);
						else
							m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE_OVER);
					}
					else if (rcMinimize.PtInRect(pMsg->pt))
					{
						if (bIconic)
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_OVER);
						else
							m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE_OVER);
					}	
					else if (rcCustom.PtInRect(pMsg->pt))
					{
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM_OVER);
					}

					DrawFrame();
				}				
				break;
			case WM_LBUTTONUP:
			case WM_NCLBUTTONUP:
				{
					if (m_nClickedBox != CLICKED_BOX_NONE)
						ReleaseCapture();

					if (rcExit.PtInRect(pMsg->pt))
					{
						if (m_nClickedBox == CLICKED_BOX_EXIT)
						{
							if (m_bExitBtnActHide)
								this->ShowWindow(SW_HIDE);
							else
							{
								if (m_bCloseEvent)
									PostMessage(WM_CLOSE, 0, 0);
								else
									OnOK();
							}
						}
					}
					else if (rcMaximize.PtInRect(pMsg->pt))
					{
						if (m_nClickedBox == CLICKED_BOX_MAXIMIZE)
						{
							if (IsZoomed())
								this->ShowWindow(SW_RESTORE);
							else
								ShowWindow(SW_MAXIMIZE);
						}
					}
					else if (rcMinimize.PtInRect(pMsg->pt))
					{
						if (m_nClickedBox == CLICKED_BOX_MINIMIZE)
						{
							if (bIconic)
								this->ShowWindow(SW_RESTORE);
							else
								this->ShowWindow(SW_SHOWMINIMIZED);
						}
					}
					else if (rcCustom.PtInRect(pMsg->pt) && m_bShowCustomBtn)
					{
						if (m_nClickedBox == CLICKED_BOX_CUSTOM)
						{						
							PostMessage(WM_CLICKCUSTOMBTN, 0, 0);
						}
					}
					else
					{					
						m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);
						m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);
						m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE);
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT);
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM);

						DrawFrame();
					}

					m_nClickedBox = CLICKED_BOX_NONE;
				}
				break;					
			}
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CSkinDialog::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages

}

void CSkinDialog::OnNcPaint()
{
	if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
	{
		DrawFrame();
	}
}

void CSkinDialog::OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp)
{
	if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
	{
		int revision = 0;

		SIZE size = Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
		if (size.cy)
		{
			revision = size.cy - (GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME));
			lpncsp->rgrc[0].top += revision;
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_LEFT);
		if (size.cx)
		{
			revision = size.cx - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].left += revision;
			//lpncsp->rgrc[0].left -= (GetSystemMetrics(SM_CXFRAME) - 1);
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT);
		if (size.cx)
		{
			revision = size.cx - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].right -= revision;
			//lpncsp->rgrc[0].right += (GetSystemMetrics(SM_CXFRAME) - 1);
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
		if (size.cy)
		{
			revision = size.cy - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].bottom -= revision;
		}
	}

	CDialog::OnNcCalcSize(bCalcValidRects, lpncsp);
}

void CSkinDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
	{
		CRect rc;
		GetWindowRect(&rc);

		int nWidth = rc.Width();
		int nHeight = rc.Height();

		int nSX = 0, nSY = 0, nOX = 0, nOY = 0;

		HRGN hRgnA, hRgnB;

		if (nType == SIZE_MAXIMIZED)
		{
			nSX = MARGIN_MAXIMIZED;
			nSY = MARGIN_MAXIMIZED;
			nWidth -= MARGIN_MAXIMIZED;
			nHeight -= MARGIN_MAXIMIZED;
		}

		if (m_hRgnWnd)
			DeleteObject(m_hRgnWnd);

		m_hRgnWnd = CreateRectRgn(nSX, nSY, nWidth, nHeight);

		// caption left
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpCapL, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeCapL.cx, nSY + m_sizeCapL.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		// caption right
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpCapR, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeCapR.cx, nSY + m_sizeCapR.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		nOX = nWidth - m_sizeCapR.cx;
		nOY = 0;
		OffsetRgn(hRgnA, nOX, nOY);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		// bottom left
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpFrmLB, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeFrmLB.cx, nSY + m_sizeFrmLB.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		nOX = 0;
		nOY = nHeight - m_sizeFrmLB.cy;
		OffsetRgn(hRgnA, nOX, nOY);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		// bottom right
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpFrmRB, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeFrmRB.cx, nSY + m_sizeFrmRB.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		nOX = nWidth - m_sizeFrmRB.cx;
		nOY = nHeight - m_sizeFrmRB.cy;
		OffsetRgn(hRgnA, nOX, nOY);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		SetWindowRgn(m_hRgnWnd, TRUE);
	}
}
